class Scheduler

# class Scheduler | The KIO::Scheduler manages io-slaves for the application. More...
Full name | `KIO::Scheduler`
Definition | `#include <scheduler.h>`
Inherits | DCOPObject (dcop) [virtual public ], QObject (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- typedef QPtrList JobList

#### Public Methods

- ~Scheduler ()
- bool connect ( const QObject *sender, const char *signal, const char *member )
- void debug_info ()
- virtual bool process (const QCString &fun, const QByteArray &data, QCString& replyType, QByteArray &replyData)
- virtual QCStringList functions ()

#### Public Slots

- void slotSlaveDied (KIO::Slave *slave)
- void slotSlaveStatus (pid_t pid, const QCString &protocol, const QString &host, bool connected)

#### Signals

- void slaveConnected (KIO::Slave *slave)
- void slaveError (KIO::Slave *slave, int error, const QString &errorMsg)

#### Public Static Methods

- static void doJob (SimpleJob *job)
- static void scheduleJob (SimpleJob *job)
- static void cancelJob (SimpleJob *job)
- static void jobFinished (KIO::SimpleJob *job, KIO::Slave *slave)
- static void putSlaveOnHold (KIO::SimpleJob *job, const KURL &url)
- static void removeSlaveOnHold ()
- static void publishSlaveOnHold ()
- static KIO::Slave * getConnectedSlave (const KURL &url, const KIO::MetaData &config = MetaData() )
- static bool assignJobToSlave (KIO::Slave *slave, KIO::SimpleJob *job)
- static bool disconnectSlave (KIO::Slave *slave)
- static void registerWindow (QWidget *wid)
- static bool connect ( const char *signal, const QObject *receiver, const char *member)
- static bool connect ( const QObject* sender, const char* signal, const QObject* receiver, const char* member )
- static bool disconnect ( const QObject* sender, const char* signal, const QObject* receiver, const char* member )
- static void checkSlaveOnHold (bool b)

#### Public Members

- Forward ProtocolInfo
- Forward JobData

#### Protected Methods

- void setupSlave (KIO::Slave *slave, const KURL &url, const QString &protocol, const QString &proxy , bool newSlave, const KIO::MetaData *config=0)
- bool startJobScheduled (ProtocolInfo *protInfo)
- bool startJobDirect ()
- Scheduler ()
- virtual void virtual_hook ( int id, void* data )

#### Protected Slots

- void startStep ()
- void slotCleanIdleSlaves ()
- void slotSlaveConnected ()
- void slotSlaveError (int error, const QString &errorMsg)
- void slotScheduleCoSlave ()
- void slotUnregisterWindow (QObject *)

## Detailed Description

The KIO::Scheduler manages io-slaves for the application. It also queues jobs and assigns the job to a slave when one becomes available.

There are 3 possible ways for a job to get a slave:

1) Direct. This is the default. When you create a job the KIO::Scheduler will be notified and will find either an existing slave that is idle or it will create a new slave for the job.

Example: TransferJob *job = KIO::get(KURL("http://www.kde.org"));

2) Scheduled If you create a lot of jobs, you might want not want to have a slave for each job. If you schedule a job, a maximum number of slaves will be created. When more jobs arrive, they will be queued. When a slave is finished with a job, it will be assigned a job from the queue.

Example:

        TransferJob *job = KIO::get(KURL("http://www.kde.org"));
        KIO::Scheduler::scheduleJob(job);

3) Connection Oriented For some operations it is important that multiple jobs use the same connection. This can only be ensured if all these jobs use the same slave.

You can ask the scheduler to open a slave for connection oriented operations. You can then use the scheduler to assign jobs to this slave. The jobs will be queued and the slave will handle these jobs one after the other.

Example:

        Slave *slave = KIO::Scheduler::getConnectedSlave(
                KURL("pop3://bastian:password@mail.kde.org"));
        TransferJob *job1 = KIO::get(
                KURL("pop3://bastian:password@mail.kde.org/msg1"));
        KIO::Scheduler::assignJobToSlave(slave, job1);
        TransferJob *job2 = KIO::get(
                KURL("pop3://bastian:password@mail.kde.org/msg2"));
        KIO::Scheduler::assignJobToSlave(slave, job2);
        TransferJob *job3 = KIO::get(
                KURL("pop3://bastian:password@mail.kde.org/msg3"));
        KIO::Scheduler::assignJobToSlave(slave, job3);

        // ... Wait for jobs to finish...

        KIO::Scheduler::disconnectSlave(slave);

typedef QPtrList JobList | ### JobList

~Scheduler () | ### ~Scheduler

void doJob (SimpleJob *job) | ### doJob

[static]

Register `job` with the scheduler. The default is to create a new slave for the job if no slave is available. This can be changed by calling scheduleJob.

void scheduleJob (SimpleJob *job) | ### scheduleJob

[static]

Calling ths function makes that `job` gets scheduled for later execution, if multiple jobs are registered it might wait for other jobs to finish.

void cancelJob (SimpleJob *job) | ### cancelJob

[static]

Stop the execution of a job.

void jobFinished (KIO::SimpleJob *job, KIO::Slave *slave) | ### jobFinished

[static]

Called when a job is done.

void putSlaveOnHold (KIO::SimpleJob *job, const KURL &url) | ### putSlaveOnHold

[static]

Puts a slave on notice. A next job may reuse this slave if it requests the same URL.

A job can be put on hold after it has emit'ed its mimetype. Based on the mimetype, the program can give control to another component in the same process which can then resume the job by simply asking for the same URL again.

void removeSlaveOnHold () | ### removeSlaveOnHold

[static]

Removes any slave that might have been put on hold. If a slave was put on hold it will be killed.

void publishSlaveOnHold () | ### publishSlaveOnHold

[static]

Send the slave that was put on hold back to KLauncher. This allows another process to take over the slave and resume the job that was started.

KIO::Slave * getConnectedSlave (const KURL &url, const KIO::MetaData &config = MetaData() ) | ### getConnectedSlave

[static]

Requests a slave for use in connection-oriented mode.

Parameters:

url | This defines the username,password,host & port to connect with.
config | Configuration data for the slave.

Returns: A pointer to a connected slave or 0 if an error occured.

See also: assignJobToSlave, disconnectSlave

bool assignJobToSlave (KIO::Slave *slave, KIO::SimpleJob *job) | ### assignJobToSlave

[static]

bool disconnectSlave (KIO::Slave *slave) | ### disconnectSlave

[static]

void registerWindow (QWidget *wid) | ### registerWindow

[static]

Register the mainwindow `wid` with the KIO subsystem Do not call this, it is called automatically from void KIO::Job::setWindow(QWidget *window)

bool connect ( const char *signal, const QObject *receiver, const char *member) | ### connect

[static]

Function to connect signals emitted by the scheduler.

See also: slaveConnected, slaveError

bool connect ( const QObject* sender, const char* signal, const QObject* receiver, const char* member ) | ### connect

[static]

bool disconnect ( const QObject* sender, const char* signal, const QObject* receiver, const char* member ) | ### disconnect

[static]

Reimplemented from QObject.

bool connect ( const QObject *sender, const char *signal, const char *member ) | ### connect

void checkSlaveOnHold (bool b) | ### checkSlaveOnHold

[static]

When true, the next job will check whether KLauncher has a slave on hold that is suitable for the job.

void debug_info () | ### debug_info

bool process (const QCString &fun, const QByteArray &data, QCString& replyType, QByteArray &replyData) | ### process

[virtual]

Reimplemented from DCOPObject.

QCStringList functions () | ### functions

[virtual]

Reimplemented from DCOPObject.

void slotSlaveDied (KIO::Slave *slave) | ### slotSlaveDied

[slot]

void slotSlaveStatus (pid_t pid, const QCString &protocol, const QString &host, bool connected) | ### slotSlaveStatus

[slot]

void slaveConnected (KIO::Slave *slave) | ### slaveConnected

[signal]

void slaveError (KIO::Slave *slave, int error, const QString &errorMsg) | ### slaveError

[signal]

void setupSlave (KIO::Slave *slave, const KURL &url, const QString &protocol, const QString &proxy , bool newSlave, const KIO::MetaData *config=0) | ### setupSlave

[protected]

bool startJobScheduled (ProtocolInfo *protInfo) | ### startJobScheduled

[protected]

bool startJobDirect () | ### startJobDirect

[protected]

Scheduler () | ### Scheduler

[protected]

void startStep () | ### startStep

[protected slots slot]

void slotCleanIdleSlaves () | ### slotCleanIdleSlaves

[protected slots slot]

void slotSlaveConnected () | ### slotSlaveConnected

[protected slots slot]

void slotSlaveError (int error, const QString &errorMsg) | ### slotSlaveError

[protected slots slot]

void slotScheduleCoSlave () | ### slotScheduleCoSlave

[protected slots slot]

void slotUnregisterWindow (QObject *) | ### slotUnregisterWindow

[protected slots slot]

void virtual_hook ( int id, void* data ) | ### virtual_hook

[protected virtual]

Reimplemented from DCOPObject.

Generated by: root on macppc.ports.openbsd.org on Sat Sep 6 10:36:57 2003, using kdoc 2.0a54.